*
      subroutine getop(cvar,value)
*
* getop: Get the value of a parameter that controls the operation
*        of the optimization subroutines.
*
* Update history
*    v1.0  18-Nov-1992  Original version
*    v1.1  20-Jul-1995  Slightly new style
*    v1.2   5-Aug-1999  Small changes
*    v1.3   6-Aug-1999  Correct error-report bug
*
      implicit none
*
* Arguments
*    cvar  = c*(?) = name of routine.variable
*    value = r*4   = value to set 
*
      character*(*) cvar
      real*4        value
*
* Common block
*    / OPHOLD / holds values of all control variables
*        CRVAR = c*16(256) = name of variables
*        VLMIN = r*4(256)  = minimum value of variables
*        VLDEF = r*4(256)  = default value of variables
*        VLMAX = r*4(256)  = maximum value of variables
*        VLSET = r*4(256)  = set value of variables
*        IINIT = i*4       = flag set if initialization done
*
      common /OPHOLD/ CRVAR,VLMIN,VLDEF,VLMAX,VLSET,IINIT
      character*16    CRVAR(256)
      real*4          VLMIN(256),VLDEF(256),VLMAX(256),VLSET(256)
      integer*4       IINIT
*
* Local variables
*    i1 = i*4 = counting index
*    i2 = i*4 = set if a match has been found
*
      integer*4 i1,i2
*
* If initialization not done, return with error message
*
      if (IINIT .le. 0) then
        write (6,699)
        return
      endif
*
* Set match variable
*
      i2=0
*
* Run through list of variable names looking for a match
*
      do i1=1,256
        if (cvar .eq. CRVAR(i1)) then
          value=VLSET(i1)
          i2   =1
        endif
      enddo
*
* If no match, report problem
*
      if (i2 .le. 0) then
        write (6,698) cvar
      endif
*
* End
*
 698  format (' *** Error: getop: variable ',a,' unknown       ***')
 699  format (' *** Error: getop: initialise using iniop first ***')
*
      end
