*
      subroutine iniop
*
* iniop: Initialise the parameters that control operation of
*        the optimization subroutines.
*
* Update history
*    v1.0  18-Nov-1992  Original version
*    v1.1  24-Jun-1996  Default to no printouts
*    v1.2   5-Jul-1996  Default to more accuracy 
*    v1.3  20-Jul-1998  Small changes
*    v1.4   6-Aug-1999  Updates to match putop, getop
*    v1.5   5-Oct-1999  Change loop default, maximum in monpo
*
      implicit none
*
* Common block
*    / OPHOLD / holds values of all control variables
*        CRVAR = c*16(256) = name of variables
*        VLMIN = r*4(256)  = minimum value of variables
*        VLDEF = r*4(256)  = default value of variables
*        VLMAX = r*4(256)  = maximum value of variables
*        VLSET = r*4(256)  = set value of variables
*        IINIT = i*4       = flag set if initialization done
*
      common /OPHOLD/ CRVAR,VLMIN,VLDEF,VLMAX,VLSET,IINIT
      character*16    CRVAR(256)
      real*4          VLMIN(256),VLDEF(256),VLMAX(256),VLSET(256)
      integer*4       IINIT
      save
*
* Local variables
*    i1 = i*4 = counting index
*
      integer*4 i1
*
* Clear arrays
*
      do i1=1,256
        CRVAR(i1)='null'
        VLMIN(i1)=0.0
        VLDEF(i1)=0.0
        VLMAX(i1)=0.0
        VLSET(i1)=0.0
      enddo
*
* Initialise counter of variables
*
      i1=0
*
* Set names of variables and the corresponding values
*
* optim
*
      i1       =i1+1
      CRVAR(i1)='OPTIM.IPRINT'
      VLMIN(i1)=0.0
      VLDEF(i1)=0.0
      VLMAX(i1)=5.0
*
* grids
*
      i1      =i1+1
      CRVAR(i1)='GRIDS.NLOOP'
      VLMIN(i1)=       8.0
      VLDEF(i1)=  131072.0
      VLMAX(i1)=16777216.0
*
      i1       =i1+1
      CRVAR(i1)='GRIDS.IPRINT'
      VLMIN(i1)=0.0
      VLDEF(i1)=0.0
      VLMAX(i1)=5.0
*
* monte
*
      i1       =i1+1
      CRVAR(i1)='MONTE.NLOOP'
      VLMIN(i1)=       1.0
      VLDEF(i1)=  131072.0
      VLMAX(i1)=16777216.0
*
      i1       =i1+1
      CRVAR(i1)='MONTE.IPRINT'
      VLMIN(i1)=0.0
      VLDEF(i1)=0.0
      VLMAX(i1)=5.0
*
* powll
*
      i1       =i1+1
      CRVAR(i1)='POWLL.NIMAX'
      VLMIN(i1)=    8.0
      VLDEF(i1)=  512.0
      VLMAX(i1)=32768.0
*
      i1       =i1+1
      CRVAR(i1)='POWLL.EPS'
      VLMIN(i1)=1.0E-12
      VLDEF(i1)=1.0E-06
      VLMAX(i1)=1.0E-03
*
      i1       =i1+1
      CRVAR(i1)='POWLL.IPRINT'
      VLMIN(i1)=0.0
      VLDEF(i1)=0.0
      VLMAX(i1)=5.0
*
* smplx
*
      i1       =i1+1
      CRVAR(i1)='SMPLX.ALPHA'
      VLMIN(i1)= 0.1
      VLDEF(i1)= 1.0
      VLMAX(i1)= 2.0
*
      i1       =i1+1
      CRVAR(i1)='SMPLX.BETA'
      VLMIN(i1)= 0.05
      VLDEF(i1)= 0.5
      VLMAX(i1)= 1.0
*
      i1       =i1+1
      CRVAR(i1)='SMPLX.GAMMA'
      VLMIN(i1)= 1.1
      VLDEF(i1)= 2.0
      VLMAX(i1)=20.0
*
      i1       =i1+1
      CRVAR(i1)='SMPLX.EPS'
      VLMIN(i1)=1.0E-12
      VLDEF(i1)=1.0E-06
      VLMAX(i1)=1.0E-03
*
      i1       =i1+1
      CRVAR(i1)='SMPLX.NIMAX'
      VLMIN(i1)=    64.0
      VLDEF(i1)=  2048.0
      VLMAX(i1)=131072.0
*
      i1       =i1+1
      CRVAR(i1)='SMPLX.IPRINT'
      VLMIN(i1)=0.0
      VLDEF(i1)=0.0
      VLMAX(i1)=5.0
*
* siman
*
      i1       =i1+1
      CRVAR(i1)='SIMAN.TCHN'
      VLMIN(i1)= 0.1000
      VLDEF(i1)= 0.9800
      VLMAX(i1)= 0.9999
*
      i1       =i1+1
      CRVAR(i1)='SIMAN.TINY'
      VLMIN(i1)= 1.0e-20
      VLDEF(i1)= 1.0e-12
      VLMAX(i1)= 1.0e-06
*
      i1       =i1+1
      CRVAR(i1)='SIMAN.NLOOP'
      VLMIN(i1)=   32.0
      VLDEF(i1)=  512.0
      VLMAX(i1)= 8192.0
*
      i1       =i1+1
      CRVAR(i1)='SIMAN.NSAMP'
      VLMIN(i1)=   16.0
      VLDEF(i1)=  256.0
      VLMAX(i1)= 4096.0
*
      i1       =i1+1
      CRVAR(i1)='SIMAN.IPRINT'
      VLMIN(i1)=0.0
      VLDEF(i1)=0.0
      VLMAX(i1)=5.0
*
* simmu
*
      i1       =i1+1
      CRVAR(i1)='SIMMU.TCHN'
      VLMIN(i1)= 0.1000
      VLDEF(i1)= 0.9500
      VLMAX(i1)= 0.9999
*
      i1       =i1+1
      CRVAR(i1)='SIMMU.TINY'
      VLMIN(i1)= 1.0e-20
      VLDEF(i1)= 1.0e-12
      VLMAX(i1)= 1.0e-06
*
      i1       =i1+1
      CRVAR(i1)='SIMMU.NLOOP'
      VLMIN(i1)=   64.0
      VLDEF(i1)= 1024.0
      VLMAX(i1)=16384.0
*
      i1       =i1+1
      CRVAR(i1)='SIMMU.NSAMP'
      VLMIN(i1)=   32.0
      VLDEF(i1)=  512.0
      VLMAX(i1)= 8196.0
*
      i1       =i1+1
      CRVAR(i1)='SIMMU.IPRINT'
      VLMIN(i1)=0.0
      VLDEF(i1)=0.0
      VLMAX(i1)=5.0
*
* simpo
*
      i1       =i1+1
      CRVAR(i1)='SIMPO.TCHN'
      VLMIN(i1)= 0.1000
      VLDEF(i1)= 0.9500
      VLMAX(i1)= 0.9999
*
      i1       =i1+1
      CRVAR(i1)='SIMPO.TINY'
      VLMIN(i1)= 1.0e-20
      VLDEF(i1)= 1.0e-12
      VLMAX(i1)= 1.0e-06
*
      i1       =i1+1
      CRVAR(i1)='SIMPO.NANNE'
      VLMIN(i1)=  1.0
      VLDEF(i1)= 16.0
      VLMAX(i1)=256.0
*
      i1       =i1+1
      CRVAR(i1)='SIMPO.NLOOP'
      VLMIN(i1)=   16.0
      VLDEF(i1)=  256.0
      VLMAX(i1)= 4096.0
*
      i1       =i1+1
      CRVAR(i1)='SIMPO.NSAMP'
      VLMIN(i1)=   16.0
      VLDEF(i1)=  128.0
      VLMAX(i1)= 1024.0
*
      i1       =i1+1
      CRVAR(i1)='SIMPO.IPRINT'
      VLMIN(i1)=0.0
      VLDEF(i1)=0.0
      VLMAX(i1)=5.0
*
* simpu
*
      i1       =i1+1
      CRVAR(i1)='SIMPU.TCHN'
      VLMIN(i1)= 0.1000
      VLDEF(i1)= 0.9500
      VLMAX(i1)= 0.9999
*
      i1       =i1+1
      CRVAR(i1)='SIMPU.TINY'
      VLMIN(i1)= 1.0e-20
      VLDEF(i1)= 1.0e-12
      VLMAX(i1)= 1.0e-06
*
      i1       =i1+1
      CRVAR(i1)='SIMPU.NANNE'
      VLMIN(i1)=   1.0
      VLDEF(i1)=  16.0
      VLMAX(i1)= 256.0
*
      i1       =i1+1
      CRVAR(i1)='SIMPU.NLOOP'
      VLMIN(i1)=   16.0
      VLDEF(i1)=  256.0
      VLMAX(i1)= 4096.0
*
      i1       =i1+1
      CRVAR(i1)='SIMPU.NSAMP'
      VLMIN(i1)=   16.0
      VLDEF(i1)=  128.0
      VLMAX(i1)= 1024.0
*
      i1       =i1+1
      CRVAR(i1)='SIMPU.IPRINT'
      VLMIN(i1)=0.0
      VLDEF(i1)=0.0
      VLMAX(i1)=5.0
*
* monpo
*
      i1       =i1+1
      CRVAR(i1)='MONPO.NLOOP'
      VLMIN(i1)=    1.0
      VLDEF(i1)= 1024.0
      VLMAX(i1)=65536.0
*
      i1       =i1+1
      CRVAR(i1)='MONPO.IPRINT'
      VLMIN(i1)=0.0
      VLDEF(i1)=0.0
      VLMAX(i1)=5.0
*
* gripo
* 
      i1       =i1+1
      CRVAR(i1)='GRIPO.NLOOP'
      VLMIN(i1)=    1.0
      VLDEF(i1)= 1024.0
      VLMAX(i1)=65536.0
*
      i1       =i1+1
      CRVAR(i1)='GRIPO.IPRINT'
      VLMIN(i1)=0.0
      VLDEF(i1)=0.0
      VLMAX(i1)=5.0
*
* error
*
      i1       =i1+1
      CRVAR(i1)='ERROR.EPS'
      VLMIN(i1)=1.0e-03
      VLDEF(i1)=1.0e-02
      VLMAX(i1)=1.0e-01
*
      i1       =i1+1
      CRVAR(i1)='ERROR.NIMAX'
      VLMIN(i1)=1.0e+01
      VLDEF(i1)=1.0e+02
      VLMAX(i1)=1.0e+03
*
      i1       =i1+1
      CRVAR(i1)='ERROR.IPRINT'
      VLMIN(i1)=0.0
      VLDEF(i1)=0.0
      VLMAX(i1)=5.0
*
* ranuni
*
      i1       =i1+1
      CRVAR(i1)='RANUNI.ISEED'
      VLMIN(i1)=   -1.0e+20
      VLDEF(i1)=14391.0
      VLMAX(i1)=    1.0e+20
*
* Make set values same as defaults
*
      do i1=1,256
        VLSET(i1)=VLDEF(i1)
      enddo
*
* Set initialization-done flag
*
      IINIT=1
*
* End
*
      end
