#!/usr/bin/perl
#
# minem_submit.perl
#
# Copyright David Wallom 2004
#############################
use Getopt::Long;
use File::Copy;
#############################

if($#ARGV<3){
    print "usage: ./minem_submit.perl -c <number of charges> -w <number of ways> -o <file root> -m <myproxy_password> OPTIONAL -r <hostname/jobmanager> -s <SRB>\n";
    exit;
}
##################
# Get current Date
##################
$date=`date +%s`;
chomp $date;
#######################
# Setup Input variables
#######################
$res = GetOptions("changes=s"    => \$CHARGE,
                  "ways=s"       => \$WAYS,
                  "outroot=s"    => \$OUTROOT,
                  "myproxy=s"    => \$MYPROXY,
                  "resource=s"   => \$HOST,
		  "gridtype=s"   => \$GRID,
                  "srb"          => \$NOSRB,
                  "help"         => \$HELP);
$MINHOME="/usr/local/applications/Minem";
######################
# Get Proxy Credential
######################
if( $MYPROXY ne "KCA"){
    if(!`echo $MYPROXY | myproxy-get-delegation -S`)
    {
	print "MyProxy credential retreival failure";
    exit;
    }
}
##############################
# Make new to run in directory
##############################
if(-e "$ENV{PWD}/Minem-$OUTROOT-$CHARGE-$WAYS"){
    system(" mv $ENV{PWD}/Minem-$OUTROOT-$CHARGE-$WAYS $ENV{PWD}/Minem-$OUTROOT-$CHARGE-$WAYS-1");
}
`mkdir $ENV{PWD}/Minem-$OUTROOT-$CHARGE-$WAYS`;
chdir ("$ENV{PWD}/Minem-$OUTROOT-$CHARGE-$WAYS");
`cp $MINHOME/make_runs .`;
`cp $MINHOME/update_file .`;
`cp $MINHOME/compile_results .`;
######################
# Make the input files
######################
`./make_runs $CHARGE $WAYS $OUTROOT >${OUTROOT}_make_runs_output 2>&1`;
###############################
# Do the analysis for each file
###############################
$int=1;
do{
    if(!$HOST){
# 	`job-submission-script -n $int -e update_file -t -a "${OUTROOT}_${CHARGE}_${int}.in ${OUTROOT}_${CHARGE}_${int}.out" -i ${OUTROOT}_${CHARGE}_${int}.in -o ${OUTROOT}_${CHARGE}_${int}.out >/dev/null 2>&1`;
 	`job-submission-script_test.perl -n $int -e update_file -t -a "${OUTROOT}_${CHARGE}_${int}.in ${OUTROOT}_${CHARGE}_${int}.out" -i ${OUTROOT}_${CHARGE}_${int}.in -o ${OUTROOT}_${CHARGE}_${int}.out -m $MYPROXY`;
    }else{
#	`job-submission-script -h $HOST -n $int -e update_file -t -a "${OUTROOT}_${CHARGE}_${int}.in ${OUTROOT}_${CHARGE}_${int}.out" -i ${OUTROOT}_${CHARGE}_${int}.in -o ${OUTROOT}_${CHARGE}_${int}.out >/dev/null 2>&1`;
	`job-submission-script_test.perl -h $HOST -n $int -e update_file -t -a "${OUTROOT}_${CHARGE}_${int}.in ${OUTROOT}_${CHARGE}_${int}.out" -i ${OUTROOT}_${CHARGE}_${int}.in -o ${OUTROOT}_${CHARGE}_${int}.out -m $MYPROXY`;
    }
    print "Submitting number ",$int,"\n";
    @JOBS=(@JOBS,$int);
    $int++;
}
while($int<=$WAYS);
print @JOBS." ".$#JOBS."\n" if($DEBUG); 
#exit;
###################################
# Wait until results have completed
###################################
until($#JOBS<0){
    foreach $a(@JOBS){
	print "${OUTROOT}_${CHARGE}_${a}.out" if($DEBUG);
	if(-s "${OUTROOT}_${CHARGE}_${a}.out"){
            delete($JOBS[$count]);
        }
	$count++;
    }
    $count=0;
    `resubmit_test.perl`;
    `sleep 20`;
}
print "Jobs done\n";  
#########################
# Compile the results now
#########################
#echo "$MINHOME/compile_results $NC $NF $OUTROOT
`./compile_results $CHARGE $WAYS $OUTROOT >${OUTROOT}_compile_results_output 2>&1`;
##########################
# Now check how long it took to run
#########################
$end=`date +%s`-$date;
`echo "This job took $end s to run">>${OUTROOT}_compile_results_output`;
#########################
# Collate all temp files
#########################
sleep(10);
`tar zcf tempfiles.tar.gz temp*.out temp*.sub temp*.err temp*.log`;
`rm temp-*`;
#######################
# Now move files to SRB
#######################
chdir ("$ENV{PWD}");
`Sinit;Scd Minem;Sput -r Minem-${OUTROOT}-${NC}-${NF};Sexit` if(!$NOSRB);
`rm -rf Minem-${OUTROOT}-${NC}-${NF}`;
#########
# The End
#########
