c
      subroutine strhed(sname,sver,sdate,buff)
c
c Subroutine strhed: Create standard header, inserting strings
c                    for routine name, version, date into buff
c
      implicit none
c
c Arguments:
c    sname = c*(*) = routine name
c    sver  = c*(*) = routine version
c    sdate = c*(*) = routine last update
c    buff  = c*(*) = string to be written
c
      character*(*) buff,sdate,sname,sver
c
c Local parameters:
c    IDATE = i*4 = starting index of date in buff
c    IEND  = i*4 = ending index for buff
c    INAME = i*4 = starting index of name in buff
c    IVER  = i*4 = starting index of version in buff
c
      integer*4  IDATE,IEND,INAME,IVER
      parameter (IDATE=61)
      parameter (IEND =72)
      parameter (INAME= 1)
      parameter (IVER =34)
c
c Local variables
c    i1    = i*4 = counting index
c    i2    = i*4 = counting index
c    ldate = i*4 = length of date string
c    lname = i*4 = length of name string
c    lver  = i*4 = length of version string
c
      integer*4 i1,i2,ldate,lname,lver
c
c Get lengths of input strings
c
      call strlen(sdate,ldate)
      call strlen(sname,lname)
      call strlen(sver ,lver )
c
c Check lengths consistent with parameters
c
      if (lname .gt. (IVER-INAME)) then
        write (6,699)
      endif
c
      if (lver  .gt. (IDATE-IVER)) then
        write (6,698)
      endif
c
      if (ldate .gt. (IEND-IDATE)) then
        write (6,697)
      endif
c
c Initialise buffer
c
      buff=' '
c
c Insert routine name
c
      do i1=1,lname
        i2         =INAME+i1-1
        buff(i2:i2)=sname(i1:i1)
      enddo
c
c Insert version number
c
      do i1=1,lver
        i2         =IVER+i1-1
        buff(i2:i2)=sver(i1:i1)
      enddo
c
c Insert date 
c
      do i1=1,ldate
        i2         =IDATE+i1-1
        buff(i2:i2)=sdate(i1:i1)
      enddo
c
c End
c
      return
c
 697  format (' * Warning: strhed: some of date may be missing    *')
 698  format (' * Warning: strhed: some of version may be missing *')
 699  format (' * Warning: strhed: some of name may be missing    *')
c
      end
